#ifndef __keyboard_h
#define __keyboard_h

#include "avr8.h"

class Keyboard {

	private:
	AT90S * at90s;
		
	protected:		
	bool pressed;

	public:
	Keyboard(){pressed=false;}
	Keyboard(AT90S * _at90s) {
		at90s = _at90s;
	}
	~Keyboard(){}

	bool is_pressed() {return pressed;}

	void press() {
		//at90s->mcucr = 0x03;
		asm("out %0, %1;" : : "i"(MCUCR),"r"(0x03));
		pressed=true;
	}

	void release() {
		//at90s->mcucr = 0x02;
		asm("out %0, %1;" : : "i"(MCUCR), "r"(0x02));
		pressed=false;
	}
};

#endif
