#include "system.h"

AT90S *  System::at90s = reinterpret_cast<AT90S*>(0x00);
Keyboard System::K(System::at90s);
Timer	 System::T(System::at90s);

void System::init() {
      asm("out %0, %1;" : : "i"(DDRB),  "r"(0xFF));
      asm("out %0, %1;" : : "i"(PORTB), "r"(0xFF));
      asm("out %0, %1;" : : "i"(SREG),  "r"(0x80));
      asm("out %0, %1;" : : "i"(GIMSK), "r"(0xC0));
      asm("out %0, %1;" : : "i"(TIMSK), "r"(0x02));
      asm("out %0, %1;" : : "i"(MCUCR), "r"(0x02));
}

void System::handle_int0() {
	if(K.is_pressed()){
		T.stop();
		K.release();
		//at90s->portb=0xff;
		asm("out %0, %1;" : : "i"(PORTB), "r"(0xFF));
	} else {
		K.press();
		T.start();
	}
}

void System::handle_timer0() {
	static int count = 0;
	count++;
	if(count==60){
		T.stop();
		count=0;
		//at90s->portb=0x00;		
		asm("out %0, %1;" : : "i"(PORTB), "r"(0x00));
	}
}
